/*
 *
 * Copyright (c) 1998 The Java Apache Project.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. Every modification must be notified to the Java Apache Project
 *    and redistribution of the modified code without prior notification
 *    is not permitted in any form.
 *
 * 4. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by the Java Apache Project
 *    (http://java.apache.org/)."
 *
 * 5. The names "Alexandria", "Apache Alexandria" and "Apache Alexandria
 *    Project" must not be used to endorse or promote products
 *    derived from this software without prior written permission.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by the Java Apache Project
 *    (http://java.apache.org/)."
 *
 * THIS SOFTWARE IS PROVIDED BY THE JAVA APACHE PROJECT "AS IS" AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE JAVA APACHE PROJECT OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * License version 1.0
 *
 */
package org.apache.maven.jxr.pacman;

import java.util.*;
import java.io.*;

/**
 * PacMan implementation of a JavaFile. This will parse out the file and
 * determine package, class, and imports
 *
 * @author <a href="mailto:burton@apache.org">Kevin A. Burton</a>
 * @version $Id: JavaFileImpl.java,v 1.1 2003/01/24 03:45:44 jvanzyl Exp $
 */
public class JavaFileImpl extends JavaFile
{

    /**
     * Create a new JavaFileImpl that points to a given file...
     *
     * @param filename
     * @exception IOException
     */
    public JavaFileImpl(String filename)
        throws IOException
    {
        this.setFilename(filename);

        //always add java.lang.* to the package imports because the JVM always
        //does this implicitly.  Unless we add this to the ImportTypes JXR
        //won't pick up on this.

        this.addImportType(new ImportType("java.lang.*"));

        //now parse out this file.

        this.parse();
    }

    /**
     * Open up the file and try to determine package, class and import
     * statements.
     */
    private void parse()
        throws IOException
    {

        StreamTokenizer stok = this.getTokenizer();

        while (stok.nextToken() != StreamTokenizer.TT_EOF)
        {

            if (stok.sval == null)
            {
                continue;
            }

            //set the package
            if (stok.sval.equals("package"))
            {
                stok.nextToken();
                this.setPackageType(new PackageType(stok.sval));
            }

            //set the imports
            if (stok.sval.equals("import"))
            {
                stok.nextToken();

                String name = stok.sval;

                /*
                WARNING: this is a bug/non-feature in the current
                StreamTokenizer.  We needed to set the comment char as "*"
                and packages that are imported with this (ex "test.*") will be
                stripped( and become "test." ).  Here we need to test for this
                and if necessary re-add the char.
                */
                if (name.charAt(name.length() - 1) == '.')
                {
                    name = name + "*";
                }

                this.addImportType(new ImportType(name));
            }

            //set the Class... if the class is found no more information is
            //valid so just break out of the while loop at this point.
            //set the imports
            if (stok.sval.equals("class") ||
                stok.sval.equals("interface"))
            {
                stok.nextToken();
                this.setClassType(new ClassType(stok.sval));
                break;
            }

        }

    }

    /** Get a StreamTokenizer for this file.  */
    private StreamTokenizer getTokenizer()
        throws IOException
    {

        if (!new File(this.getFilename()).exists())
        {
            throw new IOException(this.getFilename() + " does not exist!");
        }

        FileReader reader = new FileReader(this.getFilename());

        StreamTokenizer stok = new StreamTokenizer(reader);
        //int tok;

        stok.commentChar('*');

        // set tokenizer to skip comments
        stok.slashStarComments(true);
        stok.slashSlashComments(true);

        return stok;
    }

}
